Ti.Locale.setLanguage(Alloy.CFG.lang);

Alloy.Globals.imageQueue = {};

Alloy.Globals.activeToolbars = [];

Alloy.Globals.isIos7Plus = (OS_IOS && parseInt(Ti.Platform.version.split(".")[0]) >= 7);
Alloy.Globals.isMobile = !(Alloy.isTablet);
Alloy.Globals.iPhoneTall = (OS_IOS && Ti.Platform.osname == "iphone" && Ti.Platform.displayCaps.platformHeight == 568);
Alloy.Globals.iPhoneTall6 = (OS_IOS && Ti.Platform.osname == "iphone" && Ti.Platform.displayCaps.platformHeight == 667);
Alloy.Globals.iPhoneTall6Plus = (OS_IOS && Ti.Platform.osname == "iphone" && Ti.Platform.displayCaps.platformHeight == 736);
Alloy.Globals.screenSize = { width: Ti.Platform.displayCaps.getPlatformWidth(), height: Ti.Platform.displayCaps.getPlatformHeight() };

function fz(o, s) {
    for(var s=Math.max((+s||2),(n=""+Math.abs(o)).length); n.length<s; (n="0"+n));
    return (+o < 0 ? "-" : "") + n;
};

var N_AUTO_ONLINE = 1,
    N_FORCE_OFFLINE = 2,
    N_AUTO_OFFLINE = 3;

/* MANUAL NETWORK STATUS CONTROLLER */
var NGS = Ti.App.Properties.getInt("_netstatus") || -1;
if(!NGS || NGS === -1)
{
    Ti.App.Properties.setInt("_netstatus", (Ti.Network.online ? N_AUTO_ONLINE : N_AUTO_OFFLINE));
}
else
{
    Ti.API.log("Actual Network Status: " + NGS);
}

/*
* memoize.js
* by @philogb and @addyosmani
* with further optimizations by @mathias
* and @DmitryBaranovsk
* perf tests: http://bit.ly/q3zpG3
* Released under an MIT license.
*/
function memoize( fn ) {
    return function () {
        var args = Array.prototype.slice.call(arguments),
            hash = "",
            i = args.length;
        currentArg = null;
        while (i--) {
            currentArg = args[i];
            hash += (currentArg === Object(currentArg)) ?
            JSON.stringify(currentArg) : currentArg;
            fn.memoize || (fn.memoize = {});
        }
        return (hash in fn.memoize) ? fn.memoize[hash] :
        fn.memoize[hash] = fn.apply(this, args);
    };
};

Ti.Network.addEventListener("change", function(event) {
    var NGS = Ti.App.Properties.getInt("_netstatus") || -1;
    if(NGS !== N_FORCE_OFFLINE)
    {
        Alloy.Globals.setNetworkStatus(Ti.Network.online);
    }
});

Alloy.Globals.getLang = function()
{
	var s = (Ti.Locale.currentLocale + "").toLowerCase();
	if(s.indexOf("en") === 0)
	{
		return "en-us";
	}
	if(s.indexOf("es") === 0)
	{
		return "es-py";
	}

	return Alloy.CFG.lang;
};

Alloy.Globals.getLangText = function(first, second) {
    if(Alloy.Globals.getLang().indexOf("en") == 0) {
        return [second, first].join(" ");
    } else {
        return [first, second].join(" ");
    }
};

Alloy.Globals.setNetworkStatus = function(status)
{
    Ti.App.Properties.setInt("_netstatus", status);

    Ti.App.fireEvent("net:change", {
        status: Alloy.Globals.isOnline()
    });
};

Alloy.Globals.isOnline = function()
{
    var _netstatus = Ti.App.Properties.getInt("_netstatus");
    return (_netstatus == N_AUTO_ONLINE);
};

Alloy.Globals.registerAppForPushNotifications = function()
{
	if (Ti.Platform.name == "iPhone OS" && parseInt(Ti.Platform.version.split(".")[0]) >= 8) {
	    function registerForPush() {
	        Ti.Network.registerForPushNotifications({
	            success: successCallback,
			    error: errorCallback,
			    callback: messageCallback
	        });

	        // Remove event listener once registered for push notifications
	        Ti.App.iOS.removeEventListener('usernotificationsettings', registerForPush);
	    };

		// Wait for user settings to be registered before registering for push notifications
	    Ti.App.iOS.addEventListener('usernotificationsettings', registerForPush);

	    // Register notification types to use
	    Ti.App.iOS.registerUserNotificationSettings({
		    types: [
	            Ti.App.iOS.USER_NOTIFICATION_TYPE_ALERT,
	            Ti.App.iOS.USER_NOTIFICATION_TYPE_SOUND,
	            Ti.App.iOS.USER_NOTIFICATION_TYPE_BADGE
	        ]
	    });

	} else {
	    // For iOS 7 and earlier
	    Ti.Network.registerForPushNotifications({
		    types: [
		        Ti.Network.NOTIFICATION_TYPE_BADGE,
		        Ti.Network.NOTIFICATION_TYPE_ALERT,
		        Ti.Network.NOTIFICATION_TYPE_SOUND
		    ],
		    success: successCallback,
		    error: errorCallback,
		    callback: messageCallback
		});
	}

	function errorCallback(e) {
	    console.log("Error during registration: " + JSON.stringify(e));
	}

	function messageCallback(e) {
	    var message;
	    if (e['aps'] != undefined) {
	        if (e['aps']['alert'] != undefined) {
	            if (e['aps']['alert']['body'] != undefined) {
	                message = e['aps']['alert']['body'];
	            } else {
	                message = e['aps']['alert'];
	            }
	        } else {
	            message = 'Sem conteúdo';
	        }

	        var dialog = Ti.UI.createAlertDialog({
				message: message,
				title: 'Todobit'
			}).show();
	    }
	}

	function successCallback(e) {
	    var request = Ti.Network.createHTTPClient({
	        onload: function(e) {
	            if (request.status != 200 && request.status != 201) {
	                request.onerror(e);
	                return;
	            }
	        },
	        onerror: function(e) {
	            console.log("Register Push Service failed. Error: "  + e.error);
	        }
	    });

	    // Register device token with UA
	    request.open('GET', Alloy.CFG.defaultUrl + '/variaveis/register?tag=ios&token=' + e.deviceToken, true);
	    request.send();
	}
};

Alloy.Globals.peddingProspectsCount = function()
{
    var count = 0;

    try {
        var db = Alloy.Globals.openDatabase();
        var rs = db.execute("SELECT count(id) as cc FROM prospects WHERE syncd != 1");
        if (rs && rs.isValidRow())
        {
            count = rs.fieldByName("cc");
        }
        rs && rs.close();
        db && db.close();
    } catch(ex) {};

    return Number(count);
};

Alloy.Globals.peddingOrcamentosCount = function()
{
    var count = 0;

    try {
        var db = Alloy.Globals.openDatabase();
        var rs = db.execute("SELECT count(id) as cc FROM orcamento_detalhes WHERE syncd != 1");
        if (rs && rs.isValidRow())
        {
            count = rs.fieldByName("cc");
        }
        rs && rs.close();
        db && db.close();
    } catch(ex) {};

    return Number(count);
};

Alloy.Globals.peddingAgendaCount = function()
{
    var count = 0;

    try {
        var db = Alloy.Globals.openDatabase();
        var rs = db.execute("SELECT count(id) as cc FROM agenda WHERE syncd != 1");
        if (rs && rs.isValidRow())
        {
            count = rs.fieldByName("cc");
        }
        rs && rs.close();
        db && db.close();
    } catch(ex) {};

    return Number(count);
};

Alloy.Globals.lembreteAgendaCount = function(usuario_id)
{
    var count = 0;
    var h = new Date(), hs = [h.getFullYear(), fz(h.getMonth()+1), fz(h.getDate())].join("-");

    try {
        var db = Alloy.Globals.openDatabase();
        var rs = db.execute("SELECT count(id) as cc FROM agenda WHERE ativo != 'N' AND concluido = 'N' AND usuario_id = '" + usuario_id + "' AND data_lembrete = '" + hs + "'");
        if (rs && rs.isValidRow())
        {
            count = rs.fieldByName("cc");
        }
        rs && rs.close();
        db && db.close();
    } catch(ex) {};

    return Number(count);
};

Alloy.Globals.getAuth = function()
{
    var Usuario = Ti.App.Properties.getObject("Usuario") || null;
    if(!!Usuario && Usuario != null)
    {
        var dbUsuario = Alloy.Globals.getUsuarioById(Usuario.id);
        if(!!dbUsuario && dbUsuario != null)
        {
            Usuario = _.extend(Usuario, dbUsuario);

            return Usuario;
        }
    }

    return false;
};

Alloy.Globals.getUsuarioById = function(usuario_id)
{
    var Usuario = null;
    if(!!usuario_id)
    {
        try {
            var db = Alloy.Globals.openDatabase();
            var rs = db.execute("SELECT id, gerente_id, name, username, email, type, receive_email, telefone, celular, ws, lang, pais_base FROM usuarios WHERE id = " + usuario_id + " LIMIT 0, 1");
            if (rs && rs.isValidRow())
            {
                Usuario = {};
                Usuario.id = rs.fieldByName("id");
                Usuario.gerente_id = rs.fieldByName("gerente_id");
                Usuario.name = rs.fieldByName("name");
                Usuario.firstname = Usuario.name.split(" ")[0];
                Usuario.username = rs.fieldByName("username");
                Usuario.email = rs.fieldByName("email");
                Usuario.type = rs.fieldByName("type");
                Usuario.telefone = rs.fieldByName("telefone");
                Usuario.celular = rs.fieldByName("celular");
                Usuario.receive_email = rs.fieldByName("receive_email");
                Usuario.ws = rs.fieldByName("ws");
                Usuario.lang = rs.fieldByName("lang");
                Usuario.pais_base = rs.fieldByName("pais_base");
            }
            rs && rs.close();
            db && db.close();
        } catch(ex) {
            Usuario = null;
        };
    }

    return Usuario;
};

function getUsuarioAndEquipe(usuario_id)
{
    var equipe = [];
    if(!!usuario_id)
    {
        equipe.push(usuario_id);

        var db = Alloy.Globals.openDatabase();

        try {
            var rs = db.execute("SELECT id FROM usuarios WHERE gerente_id = " + usuario_id);
            while(rs.isValidRow()) {
                equipe.push(rs.fieldByName("id"));
                rs.next();
            }
            rs.close();
        } catch(ex) {};

        try {
            var rs2 = db.execute("SELECT usuario_id FROM usuario_gerentes WHERE gerente_id = " + usuario_id);
            while(rs2.isValidRow()) {
                equipe.push(rs2.fieldByName("usuario_id"));
                rs2.next();
            }
            rs2.close();
        } catch(ex) {};

        db && db.close();
    }

    return _.uniq(equipe);
};

Alloy.Globals.getUsuarioAndEquipe = memoize(getUsuarioAndEquipe);

Alloy.Globals.getApiUri = function(uri)
{
    var _lang = Alloy.Globals.getLang();
    var uri = Alloy.CFG.defaultUrl + (""+uri);
    if(uri.indexOf("?") === -1)
    {
        uri = uri + "?wlang=" + _lang;
    }
    else
    {
        uri = uri + "&wlang=" + _lang;
    }

    return uri;
};

Alloy.Globals.authLogout = function(success)
{
    function clearOrcamentos()
    {
        var cache = require('cache');

        var db = Alloy.Globals.openDatabase();
        db.execute("DELETE FROM orcamentos WHERE numero IS NOT NULL AND numero != '' AND numero != 0");
        db.execute("DELETE FROM orcamento_detalhes WHERE syncd = 1");
        db.execute("DELETE FROM agenda WHERE syncd = 1");
        db.execute("DELETE FROM prospects WHERE syncd = 1");
        db.execute("DELETE FROM usuario_gerentes");
        db.execute("DELETE FROM request_cache WHERE k LIKE '" + (Alloy.CFG.defaultUrl + "/orcamentos/api/list.json") + "%'");
        db.execute("DELETE FROM request_cache WHERE k LIKE '" + (Alloy.CFG.defaultUrl + "/orcamentos/api/delta") + "%'");
        db.execute("DELETE FROM request_cache WHERE k LIKE '" + (Alloy.CFG.defaultUrl + "/agenda/api/list.json") + "%'");
        db.execute("DELETE FROM request_cache WHERE k LIKE '" + (Alloy.CFG.defaultUrl + "/agenda/api/delta") + "%'");
        db.execute("DELETE FROM request_cache WHERE k LIKE '" + (Alloy.CFG.defaultUrl + "/prospects/api/list.json") + "%'");
        db.execute("DELETE FROM request_cache WHERE k LIKE '" + (Alloy.CFG.defaultUrl + "/prospects/api/delta") + "%'");
        db.close();
    };

    try {
        Ti.App.Properties.setObject("Usuario", null);
        Ti.App.Properties.removeProperty("Usuario");

        var xhr = Ti.Network.createHTTPClient({
            timeout: (10 * 1000),
            cache: false
        });
        xhr.clearCookies(Alloy.CFG.domain);
        xhr.clearCookies(Alloy.CFG.defaultUrl);

        clearOrcamentos();

        Alloy.Globals.refreshLogin();
        if(success) success();

        return true;
    } catch(ex) {
        clearOrcamentos();

        Alloy.Globals.refreshLogin();
        if(success) success();

        return false;
    }
};

Alloy.Globals.requireLogin = function(success, error)
{
    var Usuario = Alloy.Globals.getAuth();
	if(!Usuario)
    {
        var loginCtrl = Alloy.createController("login");
        loginCtrl.registerCallback(success, error);

        loginCtrl.getView().open({
            modal: true
        });
    }
    else
    {
        return success(Usuario);
    }
};

Alloy.Globals.orcamentoRating = function(orcamento_id, onClose, _parentController)
{
    var syncOrcamento = require('syncOrcamento');
    var orcamento = syncOrcamento.serializeOrcamentoCompleto({
        "Orcamento": { "id": orcamento_id }
    });
    if(!orcamento)
    {
        return false;
    }

    var orcamentoRatingCtrl = Alloy.createController("orcamento_rating");
    orcamentoRatingCtrl.setOrcamentoData(orcamento.Orcamento, orcamento.OrcamentoDetalhe[0], _parentController);
    orcamentoRatingCtrl.setOnClose(onClose);

    orcamentoRatingCtrl.getView().open({
        modal: true,
        modalStyle: Ti.UI.iOS.MODAL_PRESENTATION_FORMSHEET
    });
};

Alloy.Globals.prospectRating = function(prospect_id, onClose, _parentController)
{
    var syncProspect = require('syncProspect');
    var prospect = syncProspect.serializeProspectCompleto({
        "Prospect": { "id": prospect_id }
    });
    if(!prospect)
    {
        return false;
    }

    var prospectRatingCtrl = Alloy.createController("prospect_rating");
    prospectRatingCtrl.setProspectData(prospect.Prospect, _parentController);
    prospectRatingCtrl.setOnClose(onClose);

    prospectRatingCtrl.getView().open({
        modal: true,
        modalStyle: Ti.UI.iOS.MODAL_PRESENTATION_FORMSHEET
    });
};

Alloy.Globals.createFakeButton = function(Q, options) // Q == $
{
    if(!options.icon) options.icon = { backgroundImage: false };
    if(!options.label) options.label = { text: null };

    if(typeof options.icon == "string")
    {
        options.icon = {
            backgroundImage: options.icon
        };
    }

    if(typeof options.label == "string")
    {
        options.label = {
            text: options.label
        };
    }

    var btnFake = Ti.UI.createView(_.extend({
        touchEnabled: true,
        layout: "horizontal"
    }, options));

    if(!!options.icon && options.icon.backgroundImage && options.icon.backgroundImage !== false)
    {
        btnFake.btnIcon = Ti.UI.createView(_.extend({
            width: '20dp',
            height: '20dp',
            touchEnabled: true,
            zIndex: 3
        }, options.icon));
        btnFake.add(btnFake.btnIcon);
    }

    if(options.label.text && options.label.text != null)
    {
        btnFake.label = Q.UI.create('Label', _.extend({
            left: btnFake.icon ? '5dp' : 0,
            classes: ['label-button'],
            touchEnabled: true,
            zIndex: 2
        }, options.label));
        btnFake.add(btnFake.label);
    }

    btnFake.addEventListener('touchstart', function(event) {
        if(this.touchEnabled) this.opacity = 0.5;
    });
    btnFake.addEventListener('touchend', function(event) {
        if(this.touchEnabled) this.opacity = 1;
    });

    btnFake.setIcon(function(image) {
        if(this.btnIcon) this.btnIcon.setBackgroundImage(image);
    });

    btnFake.setLabelText(function(text) {
        if(this.label) this.label.setText(text);
    });

    return btnFake;
};

Alloy.Globals.createTopToolbar = function(Q, $view, _options) // Q == $
{
    var options = _.extend({
    	hideLeftButton: false,
    	hideLembretesCount: true
    }, _options || {});

    var Usuario = Alloy.Globals.getAuth();

    var btnUserInfo = Alloy.Globals.createFakeButton(Q, {
        icon: 'icons/white_settings.png',
        label: Usuario ? Usuario.firstname : '[username]'
    });
    btnUserInfo.addEventListener('click', function(event) {
        var dialog = Ti.UI.createOptionDialog({
            title: L('menu_usuario'),
            destructive: 4,
            selectedIndex: 3,
            options: [L('sync_off'), L('sair_logout'), L('version') + Ti.App.version, L('cancelar')]
        });
        dialog.addEventListener('click', function(event) {
            if(event.index == -2)
            {
                var orcamentosView = Alloy.createController('orcamentos').getView();
                Alloy.Globals.navGroup.openWindow(orcamentosView);
            }
            else if(event.index == -1)
            {
                var agendaView = Alloy.createController('agenda').getView();
                Alloy.Globals.navGroup.openWindow(agendaView);
            }
            else if(event.index == 0)
            {
                var syncView = Alloy.createController('sync').getView();
                syncView.open({
                    modal: true
                });
            }
            else if(event.index == 1)
            {
                var cc = Ti.UI.createAlertDialog({
                    message: L('logout_confirm'),
                    title: "Todobit",
                    cancel: 0,
                    buttonNames: [L('cancelar'), 'OK']
                });
                cc.addEventListener('click', function(e) {
                    if(e.index !== e.source.cancel)
                    {
                        Alloy.Globals.authLogout(function() {
                            Alloy.Globals.requireLogin();
                        });
                    }
                });
                cc.show();
            }
            else
            {
                // nothing
            }
        });
        dialog.show();
    });

    var btnLogin = Alloy.Globals.createFakeButton(Q, {
        icon: false,
        label: L('fazer_login')
    });
    btnLogin.addEventListener('click', function(event) {
        Alloy.Globals.requireLogin();
    });

    if(!options.hideLeftButton) $view.leftNavButton = (Usuario ? btnUserInfo : btnLogin);
    else $view.setBackButtonTitle(L('voltar'));

    var poc = Alloy.Globals.peddingOrcamentosCount();
    var pac = Alloy.Globals.peddingAgendaCount();

    var btnLembretesHoje = null;
    var lembretesHojeFake = null;
	if(!options.hideLembretesCount)
	{
		var lembretesHoje = Usuario ? Alloy.Globals.lembreteAgendaCount(Usuario.id) : 0;

        btnLembretesHoje = Alloy.Globals.createFakeButton(Q, {
	        icon: null,
	        label: { text: lembretesHoje > 0 ? ''+lembretesHoje : ' ', color: 'red' },
	        width: '32dp'
	    });
	    btnLembretesHoje.addEventListener('click', function(event) {
	        var agendaCtrl = Alloy.createController('agenda');
	        agendaCtrl.setFilterToday(true);

	        var agendaView = agendaCtrl.getView();
	        Alloy.Globals.navGroup.openWindow(agendaView);
	    });
	}
    else
    {
        var lembretesHojeFake = Ti.UI.createView({
            width: '32dp',
            height: '20dp'
        });
    }

    var btnSync = Alloy.Globals.createFakeButton(Q, {
        icon: 'icons/white_sinchronize.png',
        label: '' + (poc+pac),
        width: '53dp'
    });
    btnSync.freeRotate = false;
    btnSync.startRotate = function()
    {
        var matrix2d = Ti.UI.create2DMatrix({
            rotate: 180
        });
        var animRotate = Titanium.UI.createAnimation({
            curve: Titanium.UI.ANIMATION_CURVE_LINEAR,
            transform: matrix2d,
            duration: 700
        });
        var loopAnim = function() {
            matrix2d = matrix2d.rotate(180);
            animRotate.transform = matrix2d;
            if(btnSync.freeRotate)
            {
                btnSync.btnIcon.animate(animRotate, loopAnim);
            }
        };
        if(btnSync.freeRotate) loopAnim();
    };
    btnSync.addEventListener('click', function(event) {
        var poc = Alloy.Globals.peddingOrcamentosCount();
        var pac = Alloy.Globals.peddingAgendaCount();
        var ppc = Alloy.Globals.peddingProspectsCount();

        if((poc+pac+ppc) < 1)
        {
            Ti.UI.createAlertDialog({
                message: L('sync_empty'),
                title: "Todobit"
            }).show();
        }
        else
        {
            btnSync.freeRotate = true;
            btnSync.startRotate();

            if(poc > 0)
            {
                var syncOrcamento = require('syncOrcamento');
                syncOrcamento.sync({
                    progress: function(actual, total) {
                        Alloy.Globals.refreshLogin();
                    },
                    error: function(errorResponse) {
                        if(errorResponse.error && errorResponse.errorType && errorResponse.errorType == "general")
                        {
                            btnSync.freeRotate = false;

                            Ti.UI.createAlertDialog({
                                message: L("net_error"),
                                title: L("sync_error")
                            }).show();
                        }

                        Alloy.Globals.refreshLogin();
                    },
                    done: function() {
                        Ti.UI.createAlertDialog({
                            message: L('sync_orcamentos_sent'),
                            title: L('sync_orcamentos_alert')
                        }).show();

                        btnSync.freeRotate = false;

                        Alloy.Globals.refreshLogin();
                    }
                });
            }

            if(pac > 0)
            {
                var syncAgenda = require('syncAgenda');
                syncAgenda.sync({
                    progress: function(actual, total) {
                        Alloy.Globals.refreshLogin();
                    },
                    error: function(errorResponse) {
                        if(errorResponse.error && errorResponse.errorType && errorResponse.errorType == "general")
                        {
                            btnSync.freeRotate = false;

                            Ti.UI.createAlertDialog({
                                message: L("net_error"),
                                title: L("sync_error")
                            }).show();
                        }

                        Alloy.Globals.refreshLogin();
                    },
                    done: function() {
                        Ti.UI.createAlertDialog({
                            message: L("sync_agenda_sent"),
                            title: L("sync_agenda_alert")
                        }).show();

                        btnSync.freeRotate = false;

                        Alloy.Globals.refreshLogin();
                    }
                });
            }

            if(ppc > 0)
            {
                var syncProspect = require('syncProspect');
                syncProspect.sync({
                    progress: function(actual, total) {
                        Alloy.Globals.refreshLogin();
                    },
                    error: function(errorResponse) {
                        if(errorResponse.error && errorResponse.errorType && errorResponse.errorType == "general")
                        {
                            btnSync.freeRotate = false;

                            Ti.UI.createAlertDialog({
                                message: L("net_error"),
                                title: L("sync_error")
                            }).show();
                        }

                        Alloy.Globals.refreshLogin();
                    },
                    done: function() {
                        Ti.UI.createAlertDialog({
                            message: L("sync_prospects_sent"),
                            title: L("sync_prospects_alert")
                        }).show();

                        btnSync.freeRotate = false;

                        Alloy.Globals.refreshLogin();
                    }
                });
            }
        }
    });

    var btnStatus = Alloy.Globals.createFakeButton(Q, {
        width: '20dp',
        icon: { touchEnabled: false, backgroundImage: 'icons/white_wifi.png' },
        label: null
    });
    btnStatus.refreshStatus = function()
    {
        if(Alloy.Globals.isOnline())
        {
            this.opacity = 1;
            // this.label.setText('ON');
        }
        else
        {
            this.opacity = 0.5;
            // this.label.setText('OFF');
        }
    };
    btnStatus.addEventListener('click', function(event) {
        var realStatus = Ti.Network.online;
        var NGS = Ti.App.Properties.getInt("_netstatus") || -1;

        var cc = Ti.UI.createAlertDialog({
            message: L("net_change_confirm"),
            title: L("net_change_title"),
            cancel: 0,
            buttonNames: [L('cancelar'), 'OK']
        });
        cc.addEventListener('click', function(e) {
            if(e.index !== e.source.cancel)
            {
                if(realStatus && NGS == N_FORCE_OFFLINE)
                {
                    Alloy.Globals.setNetworkStatus(N_AUTO_ONLINE);
                }
                else
                {
                    Alloy.Globals.setNetworkStatus(N_FORCE_OFFLINE);
                }
            }
        });
        cc.show();
    });

    var rightToolbar = Ti.UI.createView({
        layout: 'horizontal',
        width: '106dp',
        height: '20dp'
    });
    rightToolbar.add(!!btnLembretesHoje ? btnLembretesHoje : lembretesHojeFake);
    rightToolbar.add(btnSync);
    rightToolbar.add(btnStatus);

    $view.rightNavButton = rightToolbar;

    Ti.App.addEventListener("net:change", function(event) {
        if(btnStatus && btnStatus.refreshStatus)
        {
            btnStatus.refreshStatus();
        }
    });

    btnStatus.refreshStatus();

    var topToolbar = {
        "container": $view,
        "hideLeftButton": options.hideLeftButton,
        "hideLembretesCount": options.hideLembretesCount,
        "btnSync": btnSync,
        "btnStatus": btnStatus,
        "btnUserInfo": btnUserInfo,
        "btnLogin": btnLogin,
        "btnLembretesHoje": btnLembretesHoje
    };

    Alloy.Globals.activeToolbars.push(topToolbar);

    return topToolbar;
};

Alloy.Globals.refreshLogin = function()
{
    var Usuario = Alloy.Globals.getAuth();

    var lembretesHoje = Usuario ? Alloy.Globals.lembreteAgendaCount(Usuario.id) : 0;
    var poc = Alloy.Globals.peddingOrcamentosCount();
    var pac = Alloy.Globals.peddingAgendaCount();
    var ppc = Alloy.Globals.peddingProspectsCount();

    _.each(Alloy.Globals.activeToolbars, function(tb) {
        try {
            if(tb.container && !tb.hideLeftButton)
            {
                tb.btnUserInfo.label.setText(Usuario ? Usuario.firstname : '[username]');

                tb.container.leftNavButton = (Usuario ? tb.btnUserInfo : tb.btnLogin);
            }
            if(tb.container && tb.btnSync)
            {
                tb.btnSync.label.setText("" + (poc+pac+ppc));
            }
            if(tb.container && !!tb.btnLembretesHoje && !!tb.btnLembretesHoje.label && !tb.hideLeftButton)
            {
            	tb.btnLembretesHoje.label.setText(lembretesHoje > 0 ? ''+lembretesHoje : ' ');
            }
        } catch(ex) {
            Ti.API.log("Erro in update Toolbar");
            Ti.API.log(ex);
        }
    });
};

Alloy.Globals.webConfirm = function(event, webView)
{
    var cc = Ti.UI.createAlertDialog({
        message: (event.msg || L("erro")),
        title: (Alloy.Globals.currentTitle || "Todobit"),
        cancel: 0,
        buttonNames: [L('cancelar'), 'OK']
    });
    cc.addEventListener('click', function(e) {
        setTimeout(function() {
            var s = (e.index !== 0) ? "true" : "false";
            var ret = webView.evalJS("AppCall.release('" + event.queueName + "', " + s + ")");
        }, 250);
    });
    cc.show();
};

Alloy.Globals.openDatabase = function()
{
    var dbFile = Alloy.CFG.db_file;
    var dbName = Alloy.CFG.db_name;

	var db = Ti.Database.install(dbFile, dbName);
	db.file.setRemoteBackup(false);

    return db;
};

/* ALERTS FROM WEBVIEW */
Ti.App.addEventListener("callAlert", function(event) {
    Ti.UI.createAlertDialog({
        message: (event.msg || L("erro")),
        title: (Alloy.Globals.currentTitle || "Todobit")
    }).show();
});
