if (typeof Alloy === 'undefined') {
    var Alloy = require('alloy');
}
if (typeof Backbone === 'undefined') {
    var Backbone = require('alloy/backbone');
}
if (typeof _ === 'undefined') {
    var _ = require('alloy/underscore')._;
}

var Cache = {
    registerCacheTable: function()
    {
        var db = Alloy.Globals.openDatabase();
        db.execute('CREATE TABLE IF NOT EXISTS request_cache (id INTEGER PRIMARY KEY, c TEXT, k TEXT, m TEXT, b BLOB, e TEXT);');
        db.execute('CREATE INDEX IF NOT EXISTS url_k ON request_cache (k);');
        db.execute('CREATE INDEX IF NOT EXISTS md5sum_m ON request_cache (m);');
        db.execute('CREATE INDEX IF NOT EXISTS expires_e ON request_cache (e);');
        db.close();
    },
    getItem: function(k, m)
    {
        var data = {'cache': false, 'data': false, 'md5sum': null, 'url': k, 'created': null};
        var query_sql = "SELECT * FROM request_cache WHERE k LIKE '"+k+"'";
        if(m) query_sql += " AND m = '" + m + "'";
        query_sql += " ORDER BY id DESC, c DESC LIMIT 0, 1";

        var db = Alloy.Globals.openDatabase();
        var rs = db.execute(query_sql);
        if (rs && rs.isValidRow())
        {
            data = _.extend(data, {
                'cache': true,
                'data': rs.fieldByName("b"),
                'md5sum': rs.fieldByName("m"),
                'created': rs.fieldByName("c"),
                '_id': rs.fieldByName("id")
            });
        }
        rs && rs.close();
        db && db.close();

        return data;
    },
    setItem: function(k, b, m, e)
    {
        b = (b || null);
        m = (m || null);
        e = (e || null);

        var today = new Date();
        var c = [today.getFullYear(), today.getMonth()+1, today.getDate()].join("-") + " " + [today.getHours(), today.getMinutes(), today.getSeconds()].join(":");

        Cache.removeItem(k, m);

        var db = Alloy.Globals.openDatabase();

        var sql = "INSERT INTO request_cache (c, k, m, b, e) VALUES (?, ?, ?, ?, ?);";
        db.execute(sql, [c, k, m, b, e]);

        db && db.close();
    },
    removeItem: function(k, m)
    {
        var currentCache = Cache.getItem(k, m);

        var db = Alloy.Globals.openDatabase();
        if(currentCache.cache && "_id" in currentCache)
        {
            if(currentCache['_id']) db.execute("DELETE FROM request_cache WHERE id = " + currentCache['_id']);
        }
        db && db.close();
    }
};

Cache.registerCacheTable();

module.exports = Cache;
